

	device ZXSPECTRUM48

		org 24000

start:
		call red_and_white_cls
.ever:		halt
		call scan_keys
		ld de,$0000
		call xy2scr
		ld b,8
		ld ix,keys_buf
.m0:		ld a,(ix)
		or a
		jr z,.m3
		inc ix
		push bc
		call pr_hex8x8
		call nxt_pr8x8
		pop bc
		djnz .m0
.m3:		xor a
		push bc
		call pr_hex8x8
		call nxt_pr8x8
		pop bc
		djnz .m3
		ld de,$0808
		call xy2scr
		ld ix,keys_buf
		ld b,8
.m1:		ld a,(ix)
		or a
		jr z,.m2
		inc ix
		push bc
		ld hl,keys_map
		ld c,a
		ld b,0
		add hl,bc
		ld a,(hl)
		call pr_smb8x8
		call nxt_pr8x8
		call nxt_pr8x8
		pop bc
		djnz .m1
		jr .ever
.m2:		ld a,32
		push bc
		call pr_smb8x8
		call nxt_pr8x8
		call nxt_pr8x8
		pop bc
		djnz .m2
		jr .ever		


pr_hex8x8:	push af
		rlca
		rlca
		rlca
		rlca
		call .m1
		pop af
.m1:		and 15
		add 48
		cp 58
		jr c,.m2
		add 7
.m2:		call pr_smb8x8
		call nxt_pr8x8
		ret


pr_smb8x8:	ld h,0
		ld l,a
		add hl,hl
		add hl,hl
		add hl,hl
		ld bc,graph
		cp 32
		jr c,.m0
		ld bc,font
.m0:		add hl,bc
		ld b,7
.m1:		ld a,(hl)
		ld (de),a
		inc hl
		inc d
		djnz .m1
		ld a,(hl)
		ld (de),a
		ret


nxt_pr8x8:	inc de
		ld a,d
		and %11111000
		ld d,a
		ret

xy2scr:		ld a,d
		and 7
		rrca
		rrca
		rrca
		or e
		ld e,a
		ld a,d
		and 24
		or 64
		ld d,a
		ret
		
red_and_white_cls:
		ld hl,22528+767
		ld a,2*8+7
		ld bc,$0003
.m0:		ld (hl),a
		dec hl
		djnz .m0
		dec c
		jr nz,.m0
		xor a
.m1:		ld (hl),a
		dec hl
		bit 5,h
		jr z,.m1
		ret

	include "keys.asm"

keys_buf:	defb 0,0,0,0,0,0,0,0,0

keys_map:	defb " ",8,"ZXCVASDFGQWERT12345"
		defb "09876POIUY",10,"LKJH"
		defb 11,9,"MNB"

font:	equ 60*256

graph:	include "graph8x8.asm"

	SAVESNA "view_keys.sna",start